#!/usr/bin/perl

do "./config.pl" || die "No config.pl file!\n";

$|=1;

srand(time|$$);

print "Reading dictionary ...";
open(FILE,$DICT);
chop(@words=<FILE>);
close(FILE);
print " done.\n";

print "Making dirs ...";
mkdir("warriors",0755) if (!(-r "warriors"));
for ($i=0; $i<$SIZE; $i++) {
	next if (-r "warriors/$i");
	mkdir("warriors/$i",0755);
}
print " done.\n";

print "Creating warriors ...\n";
for ($x=0; $x<$SIZE; $x++) {
	for ($y=0; $y<$SIZE; $y++) {
		printf("%5d %5d\r",$x,$y);
		do {
			$name="$words[int(rand($#words))]";
		} while ($name=~/^[^A-Za-z0-9]+$/ || $name_cache{$name});

		open(FILE,">warriors/$x/$y.red");
		print FILE ";System 3 warrior\n";
		print FILE ";name $name ($x,$y)\n";
		print FILE ";assert 1\n\n";
		$size=int(rand($WARSIZE)+1);
		for ($lines=0; $lines<$size; $lines++) {
			$line=MakeRandOpcode($size,$lines);
			print FILE "$line\n";
		}
		for(;$lines<$WARSIZE;$lines++) {
			print FILE "L$lines\tDAT.F\t\$ 0,\t\$ 0\t;buffer\n";
		}
		close(FILE);

		open(FILE,">warriors/$x/$y.score");
		print FILE "Size $size\n";
		print FILE "Score 0\n";
		print FILE "Fights 0\n";
		print FILE "Kids 0\n";
		print FILE "Generation 0\n";
		close(FILE);

		$name_cache{$name}=1;
	}
}

print "\nAll done.\n";
